/* Kevo -- a prototype-based object-oriented language */
/* (c) Antero Taivalsaari 1991-1993 				  */
/* Some parts (c) Antero Taivalsaari 1986-1988 		  */
/* blockfiles.h: block file management internals	  */

/* 
	Traditional Forth-style block files. 
	Not really needed in Kevo, but added for 
	compatibility.
*/

/*

The block file interface consists of the following words:

	open-blockfile		Open a block file
	close-blockfile		Close the current block file
	block				Read a block into memory

	update				Mark a block dirty, i.e. changed
	discard				Unmark a block

	save-buffers		Save all the dirty blocks onto disk
	empty-buffers		Empty the buffers

	more				Add new blocks to the end of the file
	capacity			Return the number of blocks in the file
	
*/

void pOpenBlockFile();
void pCloseBlockFile();
void pBlock();
void pUpdate();
void pDiscard();
void pSaveBuffers();
void pEmptyBuffers();
void pMore();
void pCapacity();
