/* Kevo -- a prototype-based object-oriented language */
/* (c) Antero Taivalsaari 1991-1993 				  */
/* Some parts (c) Antero Taivalsaari 1986-1988 		  */
/* portBrowser.h: Non-portable object browser		  */

/*---------------------------------------------------------------------------*/
/* Graphical user interface (GUI) initialization */

/* Basic browser operations */

void		openBrowser();
void		reuseBrowser();
void		deleteBrowser();
void		unlinkBrowser();
WindowPtr	findBrowser();

void		refreshBrowser();
void		updateBrowser();
void		updateBrowserTitle();
void		recolumnBrowser();
void		handleDoubleClick();

void		browseCloneFamilies();
void		assignObject();
void		openShellForThis();


/* Basic icon list operations */

ListHandle	buildIconList();
void		deleteIconList();
void		resizeIconList();
void		determineBrowserWindowSize();

int			nextSelectedCell();
int			prevSelectedCell();
int			countSelectedCells();

void		addNewCell();
void		removeCell();
void		hideShowCell();

void		addToCell();
void		removeFromCell();
void		renameCell();

int			cellToIndex();
PAIR*		cellToPair();

PAIR*		indexedFind();
PAIR*		getNextMaskedPair();
int			maskedCountPairs();
int			countArraySlots();


/* Auxiliary operations */

void		decodeObjectType();
void		decodeObjectName();
char*		asString();


/* 
	Each icon list has an associated structure called LINFO,
	which contains information about the view mode etc.
*/

typedef struct linfoStruct	LINFO;

struct linfoStruct {
	int			lMode;			/* icon list view mode (ALL, HIDDEN, or NONHIDDEN)	*/
	OBJECT*		target;			/* the object being browsed 						*/
	WindowPtr	prevBrowser;	/* pointer to the previous browser in the system	*/
};


/* Window info operations */

LINFO*	 createLinfo();
void	 deleteLinfo();

int		 getViewMode();
void	 setViewMode();

OBJECT*	 getBrowserTarget();
void	 setBrowserTarget();

WindowPtr getPrevBrowser();
void 	  setPrevBrowser();

