/* Kevo -- a prototype-based object-oriented language */
/* (c) Antero Taivalsaari 1991-1993 				  */
/* Some parts (c) Antero Taivalsaari 1986-1988 		  */
/* portWindows.h: Non-portable window structures and operations	*/


/* Generic printing operations */

void ownPrintf();
void ownCr();


/* Window information structure */
/* 
	Each Kevo window has one of these structs stored
	in its 'RefCon' field.
	
	Different window kinds have been listed in
	'portGlobal.h'.

	If the window is a TextEdit window, the 'wConF1' field
	contains a reference to a TextEdit. 

	If the window is a Browser window, the 'wConF1' field refers
	to the icon list.

	If the window is a plain window, then all the fields are NIL.
	
	----------
	
	The 'wConF2' and 'wConF3' fields are used only for method redefinition windows
	(which are of type TEWKind). For such window, these fields contain the object whose
	method is being redefined, and the exact pair which is being redefined.

	Added later: 'wConF2' field stores additional window information for ordinary
	browser windows.
*/

typedef struct winfoStruct	WINFO;

struct winfoStruct {
	int		wKind;		/* window kind (see portGlobal.h) */
	void*	wConF1;		/* additional window information (contents field 1) */
	void*	wConF2;		/* additional window information (contents field 2) */
	void*	wConF3;		/* additional window information (contents field 3) */
};

/* Window info operations */

WINFO*	 	createWinfo();
void	 	deleteWinfo();

TEHandle 	getWindowTE();
int		 	getWindowKind();

ListHandle	getBrowserIcons();
void		setBrowserIcons();

char*		getBrowserIdent();
void		setBrowserIdent();

OBJECT*		getMethodContext();
void		setMethodContext();

PAIR*		getMethodPair();
void		setMethodPair();


/* GUI auxiliaries */

WindowPtr buildWindow();
WindowPtr buildTEWindow();

TASK**	  determineTask();

void	  deleteWindow();
void	  resizeWindowTE();

int		  countVisibleWindow();
void	  replaceMenuMetas();

